# coding:utf-8
from dspawpy.diffusion.neb import NEB, write_neb_structures
from dspawpy.diffusion.nebtools import write_json_chain
from dspawpy.io.structure import read

# 读取初态构型
init_struct = read("dspawpy_proj/dspawpy_tests/inputs/2.15/00/structure00.as")[0]
# 读取末态构型
final_struct = read("dspawpy_proj/dspawpy_tests/inputs/2.15/04/structure04.as")[0]

neb = NEB(
    initial_structure=init_struct,  # 初态构型
    final_structure=final_struct,  # 末态构型
    nimages=8,  # 共8个构型，包括初末态
)
structures = neb.linear_interpolate()  # 线性插值
# structures = neb.idpp_interpolate()   #idpp插值

# 保存 as 结构文件到 dest 路径下
write_neb_structures(
    structures=structures,  # 插入插值后的构型链
    coords_are_cartesian=True,  # 是否以笛卡尔坐标保存
    fmt="as",  # 保存格式，支持'json', 'as', 'hzw', 'pdb', 'xyz', 'dump' 六种
    path="dspawpy_proj/dspawpy_tests/outputs/us/8neb_interpolate_structures",  # 保存路径
    prefix="structure",  # 文件名前缀
)

# 预览初插构型链
write_json_chain(
    preview=True,  # 是否为预览模式
    directory="dspawpy_proj/dspawpy_tests/outputs/us/8neb_interpolate_structures",  # NEB计算目录
    step=-1,  # 默认保存最后一个离子步（最新）的构型链
    dst="dspawpy_proj/dspawpy_tests/outputs/us/8neb",  # 保存路径
)
# write_xyz_chain(preview=True, # 是否为预览模式
#                  directory="dspawpy_proj/dspawpy_tests/outputs/us/8neb_interpolate_structures", # NEB计算目录
#                  step=-1, # 默认保存最后一个离子步（最新）的构型链
#                  dst='dspawpy_proj/dspawpy_tests/outputs/us/8neb' # 保存路径
# )
